#include <algorithm>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <fstream>
#include <iostream>
#include <sstream>
#include <vector>

using namespace std;

const int maxn = 512;

int n, k;
int h[maxn];

int err_code;
string err_msg;

int check(ifstream& f)
{
    vector<int> vis(n);

    int l;
    f >> l;

    if (!f) {
        err_msg = "failed to parse first number";
        err_code = 2;
        return -1;
    }

    for (int i = 0; i < l; i++) {
        int a, b;
        f >> a >> b;
        a--; b--;
        if (!f) {
            ostringstream ss;
            ss << "failed to read pair #" << i+1;
            err_msg = ss.str();
            err_code = 2;
            return -1;
        }

        if (a < 0 || a >= n || b < 0 || b >= n) {
            ostringstream ss;
            ss << "illegal numbers is pair #" << i+1 << ": " << a+1 << " " << b+1;
            err_msg = ss.str();
            err_code = 1;
            return -1;
        }

        int diff = abs(h[a] - h[b]);
        if (diff > k) {
            ostringstream ss;
            ss << "illegal pair #" << i+1 << ": diff = " << diff <<  " > " << k;
            err_msg = ss.str();
            err_code = 1;
            return -1;
        }

        if (vis[a] || vis[b]) {
            ostringstream ss;
            ss << "illegal pair #" << i+1 << ": cell " << (vis[a] ? a+1 : b+1) << " was visited";
            err_msg = ss.str();
            err_code = 1;
            return -1;
        }

        if (a > b) swap(a, b);

        for (int j = a+1; j < b; j++) {
            if (!vis[j]) {
                ostringstream ss;
                ss << "illegal pair #" << i+1 << ": cell " << j+1 << " was not visited";
                err_msg = ss.str();
                err_code = 1;
                return -1;
            }
        }

        vis[a] = vis[b] = 1;
    }

    return l;
}

int main(int argc, char* argv[])
{
    ifstream fin(argv[1]);
    ifstream fout(argv[2]);
    ifstream fans(argv[3]);

    fin >> n >> k;
    for (int i = 0; i < n; i++) {
        fin >> h[i];
    }

    int jury_ans = check(fans);
    if (jury_ans == -1) {
        cout << "jury error: " << err_msg << endl;
        return 3;
    }

    int cont_ans = check(fout);
    if (cont_ans == -1) {
        cout << "contestant error: " << err_msg << endl;
        return err_code;
    }

    if (cont_ans > jury_ans) {
        cout << "contestant is better: " << cont_ans << " vs. " << jury_ans << endl;
        return 3;
    }

    if (cont_ans < jury_ans) {
        cout << "jury is better: " << cont_ans << " vs. " << jury_ans << endl;
        return 1;
    }

    cout << "ok " << jury_ans << endl;
    return 0;
}
