#include <cassert>
#include <cmath>
#include <cstdio>
#include <iostream>

using namespace std;

const int maxn = 512;

int n, k;
int h[maxn];
int d[maxn][maxn], from[maxn][maxn];

void print(int i, int l)
{
    if (!d[i][l]) return;

    if (l == 2) {
        if (abs(h[i] - h[i+1]) <= k) {
            cout << i+1 << " " << i+2 << endl;
        }
    } else if (l % 2 == 0 && d[i][l] == l/2) {
        if (from[i][l] == -1) {
            print(i+1, l-2);
            cout << i+1 << " " << i+l-1+1 << endl;
        } else {
            int l1 = from[i][l]-i+1;
            print(i, l1);
            print(from[i][l]+1, l - l1);
        }
    } else {
        int l1 = from[i][l]-i;
        print(i, l1);
        print(from[i][l]+1, l - l1 - 1);
    }
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int i, j;

    cin >> n >> k;
    assert(1 <= n && n <= 500);
    assert(0 <= k && k <= 200);
    for (i = 0; i < n; i++) {
        cin >> h[i];
        assert(100 <= h[i] && h[i] <= 300);
    }

    for (int l = 1; l <= n; l++) {
        for (int i = 0; i <= n-l; i++) {
            if (l == 1) d[i][l] = 0;
            else if (l == 2) d[i][l] = abs(h[i] - h[i+1]) <= k ? 1 : 0;
            else {
                bool ok = false;
                if (l % 2 == 0) {
                    if (d[i+1][l-2] == l/2 - 1 && abs(h[i] - h[i+l-1]) <= k) {
                        d[i][l] = l/2;
                        from[i][l] = -1;
                        ok = true;
                    } else {
                        for (j = i+1; j < i+l-1; j += 2) {
                            int l1 = j-i+1;
                            int l2 = l - l1;
                            assert(l1 % 2 == 0 && l2 % 2 == 0);
                            if (d[i][l1] == l1/2 && d[j+1][l2] == l2/2) {
                                d[i][l] = l/2;
                                from[i][l] = j;
                                ok = true;
                                break;
                            }
                        }
                    }
                }
                if (!ok) {
                    d[i][l] = 0;
                    for (j = i; j < i+l; j++) {
                        int l1 = j-i;
                        int l2 = l - l1 - 1;
                        if (d[i][l1] + d[j+1][l2] > d[i][l]) {
                            d[i][l] = d[i][l1] + d[j+1][l2];
                            from[i][l] = j;
                        }
                    }
                }
            }
        }
    }

    cout << d[0][n] << endl;
    print(0, n);

    fclose(stdin); fclose(stdout);
    return 0;
}
